From 9723ec37ed86b156502fc7972a1bded35c4e55c3 Mon Sep 17 00:00:00 2001
From: Stas Sergeev <stsp@users.sourceforge.net>
Date: Thu, 11 Apr 2013 19:07:20 +0400
Subject: [PATCH] asoc: define playback stream in dummy codec

---
 sound/soc/soc-utils.c | 7 +++++++
 1 file changed, 7 insertions(+)

diff --git a/sound/soc/soc-utils.c b/sound/soc/soc-utils.c
index fe4541d..53e3c89 100644
--- a/sound/soc/soc-utils.c
+++ b/sound/soc/soc-utils.c
@@ -92,6 +92,13 @@ static struct snd_soc_platform_driver dummy_platform = {
 static struct snd_soc_codec_driver dummy_codec;
 static struct snd_soc_dai_driver dummy_dai = {
 	.name = "snd-soc-dummy-dai",
+	.playback 	= {
+		.stream_name	= "Playback",
+		.channels_min	= 1,
+		.channels_max	= 384,
+		.rates		= SNDRV_PCM_RATE_8000_96000,
+		.formats	= SNDRV_PCM_FMTBIT_S16_LE,
+	},
 };
 
 static int snd_soc_dummy_probe(struct platform_device *pdev)
-- 
1.7.11.7